unit uTZView;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, TimeZones, ComCtrls, ExtCtrls;

type
  TForm1 = class(TForm)
    ListBox1: TListBox;
    Label1: TLabel;
    LblStandardName: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    LblBias: TLabel;
    LblStandardBias: TLabel;
    Label4: TLabel;
    LblDaylightName: TLabel;
    Label6: TLabel;
    LblDayLightBias: TLabel;
    Label5: TLabel;
    LblStandardDate: TLabel;
    Label8: TLabel;
    LblDaylightDate: TLabel;
    EditYear: TEdit;
    UDYear: TUpDown;
    LblStandardEncodeDate: TLabel;
    LblDaylightEncodeDate: TLabel;
    Label7: TLabel;
    Label9: TLabel;
    LblCurBias: TLabel;
    Label11: TLabel;
    LblCurStandardName: TLabel;
    Label13: TLabel;
    LblCurStandardBias: TLabel;
    Label15: TLabel;
    LblCurStandardDate: TLabel;
    Label17: TLabel;
    LblCurDaylightName: TLabel;
    Label19: TLabel;
    LblCurDaylightBias: TLabel;
    Label21: TLabel;
    LblCurDaylightDate: TLabel;
    Bevel1: TBevel;
    Bevel2: TBevel;
    Label23: TLabel;
    Label10: TLabel;
    LblCurrentBias: TLabel;
    Label14: TLabel;
    LblCurName: TLabel;
    Bevel3: TBevel;
    Label18: TLabel;
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure ListBox1Click(Sender: TObject);
    procedure EditYearChange(Sender: TObject);
  private
    { Private-Deklarationen }
  public
    { Public-Deklarationen }
    FTimeZoneList : TTimeZonesList;
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

{$ifdef Ver90}
const
{$else}
resourcestring
{$endif}
  sTZUnknown = 'unbekannt';

procedure TForm1.FormCreate(Sender: TObject);
var
  y, m, d : Word;
  x : DWord;
  t : TTimeZoneInformation;
begin
  DecodeDate(Date,y,m,d);
  UDYear.Position:=y;
  FTimeZoneList:=TTimeZonesList.Create;
  FTimeZoneList.AssignList(ListBox1.Items);
  ListBox1.ItemIndex:=FTimeZoneList.Current;
  ListBox1Click(Nil);
  x:=GetTimeZoneInformation(t);
  if x=TIME_ZONE_ID_INVALID then begin
    LblCurName.Caption:=SysErrorMessage(GetLastError);
  end
  else begin
    case x of
      TIME_ZONE_ID_STANDARD : begin
        LblCurrentBias.Caption:=TimeZoneBiasToStr(t.Bias+t.StandardBias);
        LblCurName.Caption:=t.StandardName;
      end;
      TIME_ZONE_ID_DAYLIGHT : begin
        LblCurrentBias.Caption:=TimeZoneBiasToStr(t.Bias+t.DaylightBias);
        LblCurName.Caption:=t.DaylightName;
      end;
    else
      LblCurrentBias.Caption:=TimeZoneBiasToStr(t.Bias);
      LblCurName.Caption:=sTZUnknown;
    end;
    LblCurBias        .Caption:=TimeZoneBiasToStr(t.Bias);
    LblCurStandardName.Caption:=t.StandardName;
    LblCurStandardBias.Caption:=TimeZoneBiasToStr(t.StandardBias);
    LblCurStandardDate.Caption:=TimeZoneDateToStr(t.StandardDate);
    LblCurDaylightName.Caption:=t.DaylightName;
    LblCurDaylightBias.Caption:=TimeZoneBiasToStr(t.DaylightBias);
    LblCurDaylightDate.Caption:=TimeZoneDateToStr(t.DaylightDate);
  end;
end;

procedure TForm1.FormDestroy(Sender: TObject);
begin
  FTimeZoneList.Free;
end;

procedure TForm1.ListBox1Click(Sender: TObject);
var
  i : Integer;
  t : TTimeZoneInformation;
begin
  with ListBox1 do begin
    i:=ItemIndex;
    if i<0 then Exit;
    t:=FTimeZoneList.Items[i];
    LblBias        .Caption:=TimeZoneBiasToStr(t.Bias);
    LblStandardName.Caption:=t.StandardName;
    LblStandardBias.Caption:=TimeZoneBiasToStr(t.StandardBias);
    LblStandardDate.Caption:=TimeZoneDateToStr(t.StandardDate);
    LblDaylightName.Caption:=t.DaylightName;
    LblDaylightBias.Caption:=TimeZoneBiasToStr(t.DaylightBias);
    LblDaylightDate.Caption:=TimeZoneDateToStr(t.DaylightDate);

    LblStandardEncodeDate.Caption:=TimeZoneDateToDateTimeStr(t.StandardDate,UDYear.Position);
    LblDaylightEncodeDate.Caption:=TimeZoneDateToDateTimeStr(t.DaylightDate,UDYear.Position);
  end;
end;

procedure TForm1.EditYearChange(Sender: TObject);
begin
  ListBox1Click(Nil);
end;

end.
